/*
 * ##################################################
 * #                                                #
 * # CheeseCaskets                                  #
 * # An extended TicTacToe game                     #
 * #                                                #
 * # Copyright (C) by René Knipschild               #
 * #                                                #
 * #                          rk@reneknipschild.net #
 * #                         www.reneknipschild.net #
 * #                                                #
 * ##################################################
 *
 * File: Quit.java - core
 * Version: 0.9.6
 * Last modified: 2008/10/02 16:09 CEST
 * Author: DeeDee0815
 *
 * ===Notes==========================================
 * There are currently no notes.
 * ==================================================
 */

package net.reneknipschild.cheesecaskets.core;

import java.awt.Frame;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import net.reneknipschild.cheesecaskets.gui.BetaInfo;
import net.reneknipschild.cheesecaskets.gui.MainWindow;

public class Quit {
	private Settings settings;

	private JFrame dialogOwner;

	private MainWindow mainWindow;

	public Quit(Settings settings, Game game, MainWindow mainWindow, JFrame dialogOwner) {
		this.settings = settings;
		this.dialogOwner = dialogOwner;
		this.mainWindow = mainWindow;

		if (game.isGame()) {
			if (JOptionPane.showConfirmDialog(dialogOwner, settings.getLocalisation("exit__remark"), settings.getLocalisation("question"), JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
				shutdown();
			}
		} else {
			shutdown();
		}
	}

	private void shutdown() {
		if (dialogOwner.getExtendedState() == Frame.MAXIMIZED_BOTH || mainWindow.isFullScreen()) {
			settings.setSetting("window-x", String.valueOf(mainWindow.getWindowX()));
			settings.setSetting("window-y", String.valueOf(mainWindow.getWindowY()));
			settings.setSetting("window-width", String.valueOf(mainWindow.getWindowWidth()));
			settings.setSetting("window-height", String.valueOf(mainWindow.getWindowHeight()));
			if (dialogOwner.getExtendedState() == Frame.MAXIMIZED_BOTH || mainWindow.isMaximized()) {
				settings.setSetting("window-maximized", "true");
			} else {
				settings.setSetting("window-maximized", "false");
			}
			if (mainWindow.isFullScreen()) {
				settings.setSetting("window-fullscreen", "true");
			} else {
				settings.setSetting("window-fullscreen", "false");
			}
		} else {
			settings.setSetting("window-x", String.valueOf(dialogOwner.getX()));
			settings.setSetting("window-y", String.valueOf(dialogOwner.getY()));
			settings.setSetting("window-width", String.valueOf(dialogOwner.getWidth()));
			settings.setSetting("window-height", String.valueOf(dialogOwner.getHeight()));
			settings.setSetting("window-maximized", "false");
			settings.setSetting("window-fullscreen", "false");
		}
		settings.setSetting("window-menubar", String.valueOf(mainWindow.isMenu()));
		settings.setSetting("window-toolbar", String.valueOf(mainWindow.isToolbar()));
		settings.setSetting("window-sidebar", String.valueOf(mainWindow.isSidebar()));
		settings.setSetting("window-chat", String.valueOf(mainWindow.isChat()));
		settings.setSetting("window-statusbar", String.valueOf(mainWindow.isStatusbar()));
		settings.saveSettings();
		mainWindow.dispose();
		new BetaInfo().start();
		//System.exit(0);
	}
}