/*
 * ##################################################
 * #                                                #
 * # CheeseCaskets                                  #
 * # An extended TicTacToe game                     #
 * #                                                #
 * # Copyright (C) by René Knipschild               #
 * #                                                #
 * #                          rk@reneknipschild.net #
 * #                         www.reneknipschild.net #
 * #                                                #
 * ##################################################
 *
 * File: WaitWindow.java - gui
 * Version: 1.0.0
 * Last modified: 2008/10/10 19:51 CEST
 * Author: DeeDee0815
 *
 * ===Notes==========================================
 * There are currently no notes.
 * ==================================================
 */

package net.reneknipschild.cheesecaskets.gui;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.WindowConstants;

import net.reneknipschild.cheesecaskets.core.Settings;
import net.reneknipschild.cheesecaskets.gui.layouts.ComfortGridBagLayout;
import net.reneknipschild.cheesecaskets.tools.BitmapLoader;

public class WaitWindow extends Thread {
	private Settings settings;

	private JDialog window;

	private JLabel icon;

	private JLabel headline;

	private JProgressBar animation;

	private JFrame owner;

	public WaitWindow(JFrame owner, Settings settings) {
		this.settings = settings;
		this.owner = owner;
	}

	public void run() {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				setName("WaitWindow");
				window = new JDialog(owner, settings.getLocalisation("please_wait") + "...", true);
				window.setMinimumSize(new Dimension(450, 150));
				window.setResizable(true);
				window.setLocationRelativeTo(owner);
				window.setIconImage(BitmapLoader.getImage("Icon.png"));
				window.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
				window.setCursor(new Cursor(Cursor.WAIT_CURSOR));
				window.setLayout(new BorderLayout());
				ComfortGridBagLayout layout = new ComfortGridBagLayout();
				JPanel frame = new JPanel(layout);
				frame.setBorder(BorderFactory.createEmptyBorder(8, 8, 8, 8));
				icon = new JLabel(BitmapLoader.getIcon("Wait72x72.png"));
				headline = new JLabel(settings.getLocalisation("please_wait") + "...");
				animation = new JProgressBar();
				headline.setFont(headline.getFont().deriveFont(Font.BOLD, 24f));
				animation.setIndeterminate(true);
				layout.createGridBagConstraints(icon, 0, 0, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.NONE, 0, 0, new Insets(4, 4, 4, 4), 0, 0);
				layout.createGridBagConstraints(headline, 1, 0, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, 1, 0, new Insets(4, 4, 4, 4), 0, 0);
				layout.createGridBagConstraints(animation, 1, 1, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, 1, 0, new Insets(4, 4, 4, 4), 0, 0);
				frame.add(icon);
				frame.add(headline);
				frame.add(animation);
				window.add(frame, BorderLayout.CENTER);
				window.setVisible(true);
			}
		});
	}

	public void dispose() {
		window.dispose();
	}
}