/*
 * ##################################################
 * #                                                #
 * # CheeseCaskets                                  #
 * # An extended TicTacToe game                     #
 * #                                                #
 * # Copyright (C) by René Knipschild               #
 * #                                                #
 * #                          rk@reneknipschild.net #
 * #                         www.reneknipschild.net #
 * #                                                #
 * ##################################################
 *
 * File: AvatarViewer.java - gui/components
 * Version: 1.0.0
 * Last modified: 2008/07/23 23:44 CEST
 * Author: DeeDee0815
 *
 * ===Notes==========================================
 * There are currently no notes.
 * ==================================================
 */

package net.reneknipschild.cheesecaskets.gui.components;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

public class AvatarViewer extends JPanel {
	private static final long serialVersionUID = 1L;

	private JLabel avatarDisplay;

	private JLabel nameDisplay;

	public AvatarViewer(Icon avatar, String name) {
		setBorder(BorderFactory.createLineBorder(Color.BLACK));
		setBackground(Color.WHITE);
		setLayout(new BorderLayout());
		avatarDisplay = new JLabel();
		avatarDisplay.setIcon(avatar);
		nameDisplay = new JLabel();
		nameDisplay.setText(name);
		nameDisplay.setHorizontalAlignment(SwingConstants.CENTER);
		nameDisplay.setFont(nameDisplay.getFont().deriveFont(Font.BOLD, 16f));
		add(avatarDisplay, BorderLayout.CENTER);
		add(nameDisplay, BorderLayout.SOUTH);
	}

	public Dimension getPreferredSize() {
		return new Dimension(128, 158);
	}
}