/*
 * ##################################################
 * #                                                #
 * # CheeseCaskets                                  #
 * # An extended TicTacToe game                     #
 * #                                                #
 * # Copyright (C) by René Knipschild               #
 * #                                                #
 * #                          rk@reneknipschild.net #
 * #                         www.reneknipschild.net #
 * #                                                #
 * ##################################################
 *
 * File: TimeSelector.java - gui/components
 * Version: 1.0.0
 * Last modified: 2008/07/23 23:44 CEST
 * Author: DeeDee0815
 *
 * ===Notes==========================================
 * There are currently no notes.
 * ==================================================
 */

package net.reneknipschild.cheesecaskets.gui.components;

import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.text.DecimalFormat;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerListModel;

import net.reneknipschild.cheesecaskets.gui.layouts.ComfortGridBagLayout;

public class TimeSelector extends JPanel {
	private static final long serialVersionUID = 1L;

	private String[] values;

	private JLabel label;

	private JSpinner input;

	private SpinnerListModel list;

	public TimeSelector(String text, int minTime, int maxTime) {
		ComfortGridBagLayout layout = new ComfortGridBagLayout();
		setLayout(layout);

		values = new String[maxTime * 60];
		int k = 0;
		for (int i = minTime / 60; i < maxTime / 60; i++) {
			for (int j = 0; j < 60; j++) {
				values[k++] = String.valueOf(i) + ":" + String.valueOf(new DecimalFormat("#00").format(j));
			}
		}

		list = new SpinnerListModel(values);

		label = new JLabel(text);
		input = new JSpinner(list);

		layout.createGridBagConstraints(label, 0, 0, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.BOTH, 0, 0, new Insets(0, 0, 0, 4), 0, 0);
		layout.createGridBagConstraints(input, 1, 0, 1, 1, GridBagConstraints.CENTER, GridBagConstraints.BOTH, 1, 1, new Insets(0, 4, 0, 0), 0, 0);

		this.add(label);
		this.add(input);
	}

	public void setValue(int seconds) {
		String value = "";
		value += String.valueOf(seconds / 60);
		value += ":";
		value += String.valueOf(new DecimalFormat("#00").format(seconds % 60 / 60));
		list.setValue(value);
	}

	public int getValue() {
		int seconds = 0;
		seconds += Integer.parseInt(input.getValue().toString().split(":")[0]) * 60;
		seconds += Integer.parseInt(input.getValue().toString().split(":")[1]);
		return seconds;
	}

	public void setEnabled(boolean enabled) {
		if (enabled) {
			label.setEnabled(true);
			input.setEnabled(true);
		} else {
			label.setEnabled(false);
			input.setEnabled(false);
		}
	}
}