/*
 * ##################################################
 * #                                                #
 * # CheeseCaskets                                  #
 * # An extended TicTacToe game                     #
 * #                                                #
 * # Copyright (C) by René Knipschild               #
 * #                                                #
 * #                          rk@reneknipschild.net #
 * #                         www.reneknipschild.net #
 * #                                                #
 * ##################################################
 *
 * File: FileAction.java - tools
 * Version: 1.0.0
 * Last modified: 2008/07/23 23:44 CEST
 * Author: DeeDee0815
 *
 * ===Notes==========================================
 * There are currently no notes.
 * ==================================================
 */

package net.reneknipschild.cheesecaskets.tools;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;

public class FileAction {
	public static void copy(File in, File out) throws IOException {
		FileInputStream inFile = new FileInputStream(in);
		FileChannel inChannel = inFile.getChannel();
		FileOutputStream outFile = new FileOutputStream(out);
		FileChannel outChannel = outFile.getChannel();

		ByteBuffer buffer = ByteBuffer.allocate(1048576);
		while (inChannel.read(buffer) != -1) {
			buffer.flip();
			while (buffer.hasRemaining()) {
				outChannel.write(buffer);
			}
			buffer.clear();
		}

		inChannel.close();
		outChannel.close();
	}

	public static void move(File from, File to) throws IOException {
		copy(from, to);
		from.delete();
	}
}