/*
 * ##################################################
 * #                                                #
 * # CheeseCaskets                                  #
 * # An extended TicTacToe game                     #
 * #                                                #
 * # Copyright (C) by René Knipschild               #
 * #                                                #
 * #                          rk@reneknipschild.net #
 * #                         www.reneknipschild.net #
 * #                                                #
 * ##################################################
 *
 * File: LookAndFeelSetter.java - tools
 * Version: 1.0.2
 * Last modified: 2008/10/02 23:19 CEST
 * Author: DeeDee0815
 *
 * ===Notes==========================================
 * There are currently no notes.
 * ==================================================
 */

package net.reneknipschild.cheesecaskets.tools;

import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

import org.jvnet.substance.skin.SubstanceBusinessLookAndFeel;
import org.jvnet.substance.skin.SubstanceChallengerDeepLookAndFeel;
import org.jvnet.substance.skin.SubstanceEmeraldDuskLookAndFeel;
import org.jvnet.substance.skin.SubstanceMagmaLookAndFeel;
import org.jvnet.substance.skin.SubstanceRavenGraphiteGlassLookAndFeel;

public class LookAndFeelSetter {
	public static final int BLACK_LOOK_AND_FEEL = 0;

	public static final int SILVER_LOOK_AND_FEEL = 1;

	public static final int GREEN_LOOK_AND_FEEL = 2;

	public static final int RED_LOOK_AND_FEEL = 3;

	public static final int BLUE_LOOK_AND_FEEL = 4;

	public static void setLookAndSound(int newLook, boolean withSound) {
		setLook(newLook);
		setSound(withSound);
	}

	public static void setLook(int look) {
		switch (look) {
		case 0:
			try {
				UIManager.setLookAndFeel(new SubstanceRavenGraphiteGlassLookAndFeel());
			} catch (UnsupportedLookAndFeelException exception) {
				exception.printStackTrace();
			}
			break;
		case 1:
			try {
				UIManager.setLookAndFeel(new SubstanceBusinessLookAndFeel());
			} catch (UnsupportedLookAndFeelException exception) {
				exception.printStackTrace();
			}
			break;
		case 2:
			try {
				UIManager.setLookAndFeel(new SubstanceEmeraldDuskLookAndFeel());
			} catch (UnsupportedLookAndFeelException exception) {
				exception.printStackTrace();
			}
			break;
		case 3:
			try {
				UIManager.setLookAndFeel(new SubstanceMagmaLookAndFeel());
			} catch (UnsupportedLookAndFeelException exception) {
				exception.printStackTrace();
			}
			break;
		case 4:
			try {
				UIManager.setLookAndFeel(new SubstanceChallengerDeepLookAndFeel());
			} catch (UnsupportedLookAndFeelException exception) {
				exception.printStackTrace();
			}
			break;
		}
	}

	public static void setSound(boolean sound) {
		if (sound) {
			UIManager.put("AuditoryCues.playList", UIManager.get("AuditoryCues.allAuditoryCues"));
		} else {
			UIManager.put("AuditoryCues.playList", null);
		}
	}
}